<html>
<head>
<title>OgreGLHardwareIndexBuffer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLHardwareIndexBuffer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLHardwareIndexBuffer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __GLHARDWAREINDEXBUFFER_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __GLHARDWAREINDEXBUFFER_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLPrerequisites_8h.html">OgreGLPrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareIndexBuffer_8h.html">OgreHardwareIndexBuffer.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre { 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a><a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html">00037</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html">GLHardwareIndexBuffer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareIndexBuffer.html" title="Specialisation of HardwareBuffer for vertex index buffers, still abstract.">HardwareIndexBuffer</a>
<a name="l00038"></a>00038     {
<a name="l00039"></a>00039     <span class="keyword">private</span>:
<a name="l00040"></a><a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#ab8878299f750736f9542840ce98b33cb">00040</a>         GLuint <a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#ab8878299f750736f9542840ce98b33cb">mBufferId</a>;
<a name="l00041"></a>00041         <span class="comment">// Scratch buffer handling</span>
<a name="l00042"></a><a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#a34ae0fc667d6652842e79985446b8f39">00042</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#a34ae0fc667d6652842e79985446b8f39">mLockedToScratch</a>;
<a name="l00043"></a><a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#aabf315c5a74de24f495e589c6f9d985c">00043</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#aabf315c5a74de24f495e589c6f9d985c">mScratchOffset</a>;
<a name="l00044"></a><a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#a9eb7eb2c5f2a77f09c62c34af74329d1">00044</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#a9eb7eb2c5f2a77f09c62c34af74329d1">mScratchSize</a>;
<a name="l00045"></a><a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#abbae0f9479cf04e0fe01205ed8541ab9">00045</a>         <span class="keywordtype">void</span>* <a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#abbae0f9479cf04e0fe01205ed8541ab9">mScratchPtr</a>;
<a name="l00046"></a><a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#a22c928ced1583f59acbd5b1a81c0761e">00046</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#a22c928ced1583f59acbd5b1a81c0761e">mScratchUploadOnUnlock</a>;
<a name="l00047"></a>00047     <span class="keyword">protected</span>:
<a name="l00049"></a>00049         <span class="keywordtype">void</span>* lockImpl(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options);
<a name="l00051"></a>00051         <span class="keywordtype">void</span> unlockImpl(<span class="keywordtype">void</span>);
<a name="l00052"></a>00052     <span class="keyword">public</span>:
<a name="l00053"></a>00053         <a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html">GLHardwareIndexBuffer</a>(<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* mgr, <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326">IndexType</a> idxType, <span class="keywordtype">size_t</span> numIndexes, 
<a name="l00054"></a>00054             <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> useShadowBuffer); 
<a name="l00055"></a>00055         ~<a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html">GLHardwareIndexBuffer</a>();
<a name="l00057"></a>00057         <span class="keywordtype">void</span> readData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keywordtype">void</span>* pDest);
<a name="l00059"></a>00059         <span class="keywordtype">void</span> writeData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, 
<a name="l00060"></a>00060             <span class="keyword">const</span> <span class="keywordtype">void</span>* pSource, <span class="keywordtype">bool</span> discardWholeBuffer = <span class="keyword">false</span>);
<a name="l00062"></a>00062         <span class="keywordtype">void</span> _updateFromShadow(<span class="keywordtype">void</span>);
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#abdadb26ff3b50fe784a356451a761426">00064</a>         GLuint <a class="code" href="classOgre_1_1GLHardwareIndexBuffer.html#abdadb26ff3b50fe784a356451a761426">getGLBufferId</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mBufferId; }
<a name="l00065"></a>00065     };
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 }
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 <span class="preprocessor">#endif // __GLHARDWAREINDEXBUFFER_H__</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
